Index: Singular/LIB/hnoether.lib
===================================================================
--- Singular/LIB/hnoether.lib	(revision 54ff35fb086438cda61fdfdc9ab33efa8472e4eb)
+++ Singular/LIB/hnoether.lib	(revision 7fa60f271650fb75da945dbf4eae02cf8cc5a570)
@@ -3370,71 +3165,53 @@
     {"2nd step: Treat Newton polygon until height",grenze2;}
  if (grenze2>0) {
+
+  if (EXTHNEnumber>0){ EXTHNEring = EXTHNEring(1..EXTHNEnumber); }
+
+  if (essential==1) { number_of_letztring=0; }
+  if (number_of_letztring==0) { setring HNEring; }
+  else                        { setring EXTHNEring(number_of_letztring); }
   map xytausch=basering,y,x;
+
+  HNE_RingDATA = list(HNEring, HNE_noparam, EXTHNEnumber, EXTHNEring,
+                      number_of_letztring); 
+  list hilflist=HN(HNE_RingDATA,xytausch(f),grenze2,1,essential,1,hne_conj,1);
+  kill HNEring, HNE_noparam;
+  if (EXTHNEnumber>0){ kill EXTHNEring(1..EXTHNEnumber); }
+  def HNEring = hilflist[1][1];
+  def HNE_noparam = hilflist[1][2];
+  EXTHNEnumber = hilflist[1][3];
+  for (i=1; i<=EXTHNEnumber; i++) { def EXTHNEring(i)=hilflist[1][4][i]; }
+  if (hilflist[2]==0) { setring HNEring; number_of_letztring=0; }
+  else                { setring EXTHNEring(hilflist[2]); 
+                        number_of_letztring=hilflist[2]; }
+  if (hilflist[3]==1){field_ext=1;}
+  hne_conj=hilflist[5];
   kill hilflist;
-  def letztring=basering;
-  if (EXTHNEnumber==0) { setring HNEring; }
-  else                 { setring EXTHNEring(EXTHNEnumber); }
-  list hilflist=HN(xytausch(f),grenze2,1,essential);
-  if (typeof(hilflist[1][1])=="ideal") { hilflist[1]=list(); }
-  if (not defined(Ergebnis)) {
- //-- HN wurde schon mal ausgefuehrt; Ringwechsel beim zweiten Aufruf von HN --
-    if (defined(HNDebugOn)) {" ring change in HN(",1,") detected";}
-    poly transfproc=hilflist[2];
-    map hole=HNE_noparam,transfproc,x,y;
-    setring HNE_noparam;
-    list Ergebnis=imap(letztring,Ergebnis);
-    setring EXTHNEring(EXTHNEnumber);
-    list Ergebnis=hole(Ergebnis);
-  }
-  Ergebnis=Ergebnis+extractHNEs(hilflist[1],1);
  }
  if (NullHNEx==1) {
-  Ergebnis=Ergebnis+list(list(matrix(ideal(0,x)),intvec(1),int(1),poly(0)));
- }
- //------------------- Loesche globale, nicht mehr benoetigte Objekte: --------
- if (EXTHNEnumber>0) {
-  if(system("with","Namespaces")) { kill Top::HNEring; }
-  if (defined(HNEring)) { kill HNEring; }
-  def HNEring=EXTHNEring(EXTHNEnumber);
-  setring HNEring;
-  export HNEring;
-  kill EXTHNEring(1..EXTHNEnumber);
- }
- kill HNE_noparam;
- kill EXTHNEnumber;
- export Ergebnis;
- keepring basering;
-
- return(Ergebnis);
-}
-
-///////////////////////////////////////////////////////////////////////////////
-//         
-//  the command essdevelop is obsolete  --> here is the former help string:
-//
-///////////////////////////////////////////////////////////////////////////////
-//ASSUME:  f is a bivariate polynomial (in the first 2 ring variables)
-//CREATE:  ring with name @code{HNEring}, variables @code{x,y} and ordering
-//         @code{ls} over a field extension of the current basering's ground 
-//         field. @*
-//         Since the Hamburger-Noether development of a reducible curve
-//         singularity usually does not exist in the originally given basering,
-//         @code{essdevelop} always defines @code{HNEring} and CHANGES to it.
-//         The field extension is chosen minimally.
-//RETURN:  list @code{L} of lists @code{L[i]} (corresponding to the output of
-//         @code{develop(f[i])}, f[i] an \"essential\" branch of f, but the
-//         last entry being omitted).@*
-//         For more details type @code{help reddevelop;}.
-//NOTE:    If the HNE needs a field extension, some of the branches will be
-//         conjugate. In this case @code{essdevelop} reduces the computation to
-//         one representative for each group of conjugate branches.@*
-//         Note that the degree of each branch is in general less than the
-//         degree of the field extension in which all HNEs can be put.@*
-//         Use @code{reddevelop} or @code{HNdevelop} to compute a complete HNE,
-//         i.e., a HNE for all branches.@*
-//         If @code{printlevel>=0} comments are displayed (default is
-//         @code{printlevel=0}).
-//SEE ALSO: hnexpansion, develop, reddevelop, HNdevelop, extdevelop
-//EXAMPLE: example essdevelop;  shows an example
+  if ((typeof(hne[1])=="ideal")) { hne=list(); }
+  hne=hne+list(list(matrix(ideal(0,x)),intvec(1),int(1),poly(0)));
+  if (hne_conj==0) { hne_conj=1; }
+  else { hne_conj = hne_conj, 1; }
+ }
+
+
+ // --- aufraeumen ---
+ if (defined(HNEakut)){ 
+   kill HNEakut,faktoren,deltais,transformiert,teiler,leitf;
+ }
+ if (defined(hilflist)) {kill hilflist;}
+ if (defined(erg)) {kill erg;}
+ if (defined(delt)) {kill delt;}
+ if (defined(azeilen)) { kill azeilen;}
+ if (defined(aneu)) { kill aneu;}
+ if (defined(transfproc)) { kill transfproc;}
+ if (defined(transf)) { kill transf;}
+ if (not(defined(f))) { poly f = imap(HNEring,f); export f; }
+
+ return(list(basering,field_ext,hne_conj));
+}
+
+//////////////////////////////////////////////////////////////////////////////
 proc essdevelop (poly f)
 "USAGE:   essdevelop(f); f poly
@@ -3443,58 +3220,49 @@
 "
 {
- list Ergebnis=pre_HN(f,1);
- dbprint(printlevel-voice+2,
-    "// result: "+string(size(Ergebnis))+" branch(es) successfully computed;");
- if (string(minpoly) <> "0") {
-   dbprint(printlevel-voice+2,
-    "// note that conjugate branches are omitted and that the number",
-    "// of branches represented by each remaining one may vary!");
- }
- dbprint(printlevel-voice+2,
-    "// basering has changed to HNEring");
- export Ergebnis;
- keepring basering;
+ printlevel=printlevel+1;
+ list Ergebnis=hnexpansion(f,1);
+ printlevel=printlevel-1;
  return(Ergebnis);
 }
-example
-{
-  // -------- prepare for example ---------
-  if (nameof(basering)=="HNEring") {
-   def rettering=HNEring;
-   kill HNEring;
-  }
-  // ------ the example starts here -------
-  "EXAMPLE:"; echo = 2;
-  ring r=2,(x,y),dp;
-  poly f=(x4+x2y+y2)*(x3+xy2+y3);
-  // --------- compute all branches: ---------
-  list hne=reddevelop(f);
-  displayHNE(hne[1]);   // HN-matrix of 1st branch
-  displayHNE(hne[4]);   // HN-matrix of 4th branch
-  setring r;
-  kill HNEring;
-  // --- compute only one of conjugate branches: ---
-  list hne=essdevelop(f);
-  displayHNE(hne);
-  // no. 1 of essdevelop represents no. 1 - 3 of reddevelop and
-  // no. 2 of essdevelop represents no. 4 + 5 of reddevelop
-  kill HNEring,r;
-  echo = 0;
-  // --- restore HNEring if previously defined ---
-  if (defined(rettering)) {
-   setring rettering;
-   def HNEring=rettering;
-   export HNEring;
-  }
-}
-
-///////////////////////////////////////////////////////////////////////////////
-static proc HN (poly f,int grenze, int Aufruf_Ebene, int essential)
-"NOTE: This procedure is only for internal use, it is called via pre_HN"
+
+///////////////////////////////////////////////////////////////////////////////
+static proc HN (list HNE_RingDATA,poly fneu,int grenze,Aufruf_Ebene,
+                     essential,getauscht,intvec hne_conj,int conj_factor)  
+"NOTE: This procedure is only for internal use, it is called via pre_HN
+RETURN: list: first entry = list of HNErings, 
+              second entry = number of new base ring (0 for HNEring,
+                                                      -1 for HNE_noparam,
+                                                      i for EXTHNEring(i))
+              third entry = 0 if no field extension necessary
+                            1 if field extension necessary
+              forth entry = HNEs (only if no change of basering)
+"
 {
  //---------- Variablendefinitionen fuer den unverzweigten Teil: --------------
  if (defined(HNDebugOn)) {"procedure HN",Aufruf_Ebene;}
- int Abbruch,ende,i,j,e,M,N,Q,R,zeiger,zeile,zeilevorher;
+ int Abbruch,ende,i,j,k,e,M,N,Q,R,zeiger,zeile,zeilevorher,dd;
  intvec hqs;
+ int field_ext;
+ int ring_changed, hneshift;
+ intvec conjugates,conj2,conj1;
+
+ list EXTHNEring;
+ def HNEring = HNE_RingDATA[1];
+ def HNE_noparam = HNE_RingDATA[2];
+ int EXTHNEnumber = HNE_RingDATA[3];
+ for (i=1; i<=EXTHNEnumber; i++) { def EXTHNEring(i)=HNE_RingDATA[4][i]; }
+ int number_of_letztring = HNE_RingDATA[5];
+ if (defined(basering))
+ { 
+   if (number_of_letztring==0) { kill HNEring; def HNEring=basering; }
+   else                 { kill EXTHNEring(number_of_letztring); 
+                          def EXTHNEring(number_of_letztring)=basering; }
+ }
+ else
+ {
+   if ( number_of_letztring==0) { setring HNEring; }
+   else                         { setring EXTHNEring(number_of_letztring); } 
+ }
+ if (not(defined(hne))) {list hne;}
  poly fvorher;
  list erg=ideal(0); list HNEs=ideal(0); // um die Listen an den Ring zu binden
@@ -3511,9 +3279,10 @@
  int p = char(basering);                // Ringcharakteristik
  list azeilen=ideal(0);
- ideal hilfid; list hilflist=ideal(0); intvec hilfvec;
+
+ ideal hilfid; intvec hilfvec;
 
  // ======================= der unverzweigte Teil: ============================
  while (Abbruch==0) {
-  Newton=newtonpoly(f,1);
+  Newton=newtonpoly(fneu,1);
   zeiger=find_in_list(Newton,grenze);
   if (Newton[zeiger][2] != grenze)
@@ -3526,9 +3295,9 @@
     Q = M / N;
 
- //-------- 1. Versuch: ist der quasihomogene Leitterm reine Potenz ? ---------
- //              (dann geht alles wie im irreduziblen Fall)
- //----------------------------------------------------------------------------
+    //-------- 1. Versuch: ist der quasihomogene Leitterm reine Potenz ? ------
+    //              (dann geht alles wie im irreduziblen Fall)
+    //-------------------------------------------------------------------------
     e = gcd(M,N);
-    delt=factorfirst(redleit(f,Newton[zeiger],Newton[zeiger+1])
+    delt=factorfirst(redleit(fneu,Newton[zeiger],Newton[zeiger+1])
                       /x^Newton[zeiger][1],M,N);
     if (delt==0) {
@@ -3537,9 +3306,9 @@
     }
     if (Abbruch==0) {
- //-------------- f,zeile retten fuer den Spezialfall (###): ------------------
-      fvorher=f;zeilevorher=zeile;
+      //----------- fneu,zeile retten fuer den Spezialfall (###): -------------
+      fvorher=fneu;zeilevorher=zeile;
       if (R==0) {
- //------------- transformiere f mit T1, wenn kein Abbruch nachher: -----------
-        if (N>1) { f = T1_Transform(f,delt,M/ e); }
+        //-------- transformiere fneu mit T1, wenn kein Abbruch nachher: ------
+        if (N>1) { fneu = T1_Transform(fneu,delt,M/ e); }
         else     { ende=1; }
         if (defined(HNDebugOn)) {"a("+string(zeile)+","+string(Q)+") =",delt;}
@@ -3547,15 +3316,15 @@
       }
       else {
- //------------- R > 0 : transformiere f mit T2 -------------------------------
-        erg=T2_Transform(f,delt,M,N,referencepoly(Newton));
-        f=erg[1];delt=erg[2];
- //------- vollziehe Euklid.Alg. nach, um die HN-Matrix zu berechnen: ---------
+        //------------- R > 0 : transformiere fneu mit T2 ---------------------
+        erg=T2_Transform(fneu,delt,M,N,referencepoly(Newton));
+        fneu=erg[1];delt=erg[2];
+        //----- vollziehe Euklid.Alg. nach, um die HN-Matrix zu berechnen: ----
         while (R!=0) {
          if (defined(HNDebugOn)) { "h("+string(zeile)+") =",Q; }
          hqs[zeile+1]=Q;         // denn zeile beginnt mit dem Wert 0
- //------------------ markiere das Zeilenende der HNE: ------------------------
+         //--------------- markiere das Zeilenende der HNE: -------------------
          azeilen[zeile+1][Q+1]=x;
          zeile=zeile+1;
- //----------- Bereitstellung von Speicherplatz fuer eine neue Zeile: ---------
+         //-------- Bereitstellung von Speicherplatz fuer eine neue Zeile: ----
          azeilen[zeile+1]=ideal(0);
          M=N; N=R; R=M%N; Q=M / N;
@@ -3564,27 +3333,31 @@
         azeilen[zeile+1][Q]=delt;
       }
-      if (defined(HNDebugOn)) {"transformed polynomial: ",f;}
+      if (defined(HNDebugOn)) {"transformed polynomial: ",fneu;}
       grenze=e;
- //----------------------- teste Abbruchbedingungen: --------------------------
-      if (subst(f,y,0)==0) {              // <==> y|f
+      //----------------------- teste Abbruchbedingungen: ---------------------
+      if (subst(fneu,y,0)==0) {              // <==> y|fneu
         dbprint(printlevel-voice+3,"finite HNE of one branch found");
            // voice abzufragen macht bei rekursiven procs keinen Sinn
         azeilen[zeile+1][Q+1]=x;
- //- Q wird nur in hqs eingetragen, wenn der Spezialfall nicht eintritt (s.u.)-
+        //----- Q wird nur in hqs eingetragen, wenn der Spezialfall nicht 
+        //      eintritt (siehe unten) -----
         Abbruch=2;
         if (grenze>1) {
-         if (jet(f,1,intvec(0,1))==0) {
- //------ jet(...)=alle Monome von f, die nicht durch y2 teilbar sind ---------
- "THE TEST FOR SQUAREFREENESS WAS BAD!! The polynomial was NOT squarefree!!!";}
+         if (jet(fneu,1,intvec(0,1))==0) {
+           //- jet(...)=alle Monome von fneu, die nicht durch y2 teilbar sind -
+           "THE TEST FOR SQUAREFREENESS WAS BAD!!";
+           " The polynomial was NOT squarefree!!!";}
          else {
- //-------------------------- Spezialfall (###): ------------------------------
- // Wir haben das Problem, dass die HNE eines Zweiges hier abbricht, aber ein
- // anderer Zweig bis hierher genau die gleiche HNE hat, die noch weiter geht
- // Loesung: mache Transform. rueckgaengig und behandle f im Verzweigungsteil
- //----------------------------------------------------------------------------
+           //----------------------- Spezialfall (###): -----------------------
+           // Wir haben das Problem, dass die HNE eines Zweiges hier abbricht,
+           // aber ein anderer Zweig bis hierher genau die gleiche HNE hat, die
+           // noch weiter geht 
+           // Loesung: mache Transform. rueckgaengig und behandle fneu im 
+           // Verzweigungsteil
+           //------------------------------------------------------------------
           Abbruch=1;
-          f=fvorher;zeile=zeilevorher;grenze=Newton[zeiger][2];
+          fneu=fvorher;zeile=zeilevorher;grenze=Newton[zeiger][2];
         }}
-        else {f=0;}     // f nicht mehr gebraucht - spare Speicher
+        else {fneu=0;}     // fneu nicht mehr gebraucht - spare Speicher
         if (Abbruch==2) { hqs[zeile+1]=Q; }
       }                 // Spezialfall nicht eingetreten
@@ -3600,12 +3373,11 @@
 
  // ===================== der Teil bei Verzweigung: ===========================
-
  if (Abbruch==1) {
- //---------- Variablendefinitionen fuer den verzweigten Teil: ----------------
+  //---------- Variablendefinitionen fuer den verzweigten Teil: ---------------
   poly leitf,teiler,transformiert;
   list aneu=ideal(0);
   list faktoren;
-  list HNEakut=ideal(0);
   ideal deltais;
+  list HNEakut=ideal(0);  
   intvec eis;
   int zaehler,hnezaehler,zl,zl1,M1,N1,R1,Q1,needext;
@@ -3620,6 +3392,29 @@
   azeilen=list(hqs)+azeilen; // hat jetzt Struktur von HNEs: hqs in der 1.Zeile
 
- //======= Schleife fuer jede zu betrachtende Seite des Newtonpolygons: =======
+  //======= Schleife fuer jede zu betrachtende Seite des Newtonpolygons: ======
   for(i=zeiger; i<size(Newton); i++) {
+   if ((essential==1) and (EXTHNEnumber>number_of_letztring)) { 
+     // ----- setze ring zurueck fuer neue Kante  -----
+     // ---- (damit konjugierte Zweige erkennbar) -----
+     hneshift=hneshift+hnezaehler;
+     hnezaehler=0;
+     ring_changed=0;
+     def SaveRing = EXTHNEring(EXTHNEnumber);
+     setring SaveRing;
+     if (not(defined(HNEs))) { // HN wurde zum 2.Mal von pre_HN aufgerufen
+       list HNEs=ideal(0); 
+     }
+     for (k=number_of_letztring+1; k<=EXTHNEnumber; k++) { kill EXTHNEring(k);}
+     EXTHNEnumber=number_of_letztring;    
+     if (EXTHNEnumber==0) { setring HNEring; }
+     else                 { setring EXTHNEring(EXTHNEnumber); }
+     if (not(defined(HNEs))) { list HNEs; }
+     HNEs=ideal(0);
+     deltais=0;
+     delt=0;
+     if (defined(zerlege)) { kill zerlege; }
+"Hier durch gelaufen";
+   }
+
    if (defined(HNDebugOn)) { "we consider side",Newton[i],Newton[i+1]; }
    M=Newton[i+1][1]-Newton[i][1];
@@ -3631,31 +3426,52 @@
    letztringname=nameof(basering);
    lastRingnumber=EXTHNEnumber;
-   faktoren=list(ideal(charPoly(redleit(f,Newton[i],Newton[i+1])
+   faktoren=list(ideal(charPoly(redleit(fneu,Newton[i],Newton[i+1])
                        /(x^Newton[i][1]*y^Newton[i+1][2]),M,N)  ),
                  intvec(1));                  // = (zu faktoriserendes Poly, 1)
-
- //-- wechsle so lange in Ringerw., bis Leitform vollst. in Linearfakt. zerf.:-
+   conjugates=1;
+
+   //-- wechsle so lange in Ringerweiterungen, bis Leitform vollstaendig
+   //   in Linearfaktoren zerfaellt -----
    for (numberofRingchanges=1; needext==1; numberofRingchanges++) {
-    leitf=redleit(f,Newton[i],Newton[i+1])/(x^Newton[i][1]*y^Newton[i+1][2]);
+    leitf=redleit(fneu,Newton[i],Newton[i+1])/
+                     (x^Newton[i][1]*y^Newton[i+1][2]); 
     delt=factorfirst(leitf,M,N);
     needext=0;
     if (delt==0) {
-
- //---------- Sonderbehandlung: faktorisiere einige Polynome ueber Q(a): -------
-     if (charstr(basering)=="0,a") {
-//*CL old: faktoren=factorize(charPoly(leitf,M,N),2);  // damit funktion. Bsp. Baladi 5
-         faktoren=factorize(charPoly(leitf,M,N));  
+     //---------- Sonderbehandlung: faktorisiere einige Polynome ueber Q(a): --
+     if ((charstr(basering)=="0,a") and (essential==0)) {
+        faktoren=factorize(charPoly(leitf,M,N));  
+        conjugates=1;
+        for (k=2;k<=size(faktoren[2]);k++) {conjugates=conjugates,1;}
      }
      else {
- //------------------ faktorisiere das charakt. Polynom: ----------------------
+       //------------------ faktorisiere das charakt. Polynom: ----------------
        if ((numberofRingchanges==1) or (essential==0)) {
-         faktoren=factorlist(faktoren);
+         def L_help=factorlist(faktoren,conjugates);
+         faktoren=L_help[1];
+         conjugates=L_help[2]*conj_factor;
+         kill L_help;
        }
        else {     // eliminiere alle konjugierten Nullstellen bis auf eine:
          ideal hilf_id;
          for (zaehler=1; zaehler<=size(faktoren[1]); zaehler++) {
-           hilf_id=factorize(faktoren[1][zaehler])[1];
-           if (size(hilf_id)>1) { faktoren[1][zaehler]=hilf_id[2]; }
-           else                 { faktoren[1][zaehler]=hilf_id[1]; }
+           hilf_id=factorize(faktoren[1][zaehler],1);  // war vorher ...)[1];
+           if (size(hilf_id)>1) {
+             poly fac=hilf_id[1];
+             dd=deg(fac);
+             // Zur Sicherheit:
+             if (deg(fac)==0) { fac=hilf_id[2]; }
+             for (k=2;k<=size(hilf_id);k++) {
+               dd=dd+deg(hilf_id[k]);
+               if (deg(hilf_id[k])<deg(fac)) { fac=hilf_id[k]; } 
+             }
+             faktoren[1][zaehler]=fac;
+             kill fac; 
+             conjugates[zaehler]=conj_factor*dd; 
+           }
+           else { 
+             faktoren[1][zaehler]=hilf_id[1]; 
+             conjugates[zaehler]=conj_factor; 
+           }
          }
        }
@@ -3665,9 +3481,10 @@
      for (j=1; j<=size(faktoren[2]); j++) {
       teiler=faktoren[1][j];
-      if (teiler/y != 0) {         // sonst war's eine Einheit --> wegwerfen!
+      if (teiler/y != 0) {         // sonst war's eine Konstante --> wegwerfen!
         if (defined(HNDebugOn)) {"factor of leading form found:",teiler;}
         if (teiler/y2 == 0) {      // --> Faktor hat die Form cy+d
           deltais[zaehler]=-subst(teiler,y,0)/koeff(teiler,0,1); //=-d/c
           eis[zaehler]=faktoren[2][j];
+          conj2[zaehler]=conjugates[j];
           zaehler++;
         }
@@ -3675,63 +3492,82 @@
           dbprint(printlevel-voice+2,
              " Change of basering (field extension) necessary!");
-          if (defined(HNDebugOn)) { teiler,"is not properly factored!"; }
+          if (defined(HNDebugOn)) { teiler,"is not yet properly factorized!"; }
           if (needext==0) { poly zerlege=teiler; }
           needext=1;
+          field_ext=1;
         }
       }
-     }                             // end(for j)
+     }  // end(for j)
     }
-    else { deltais=ideal(delt); eis=e;}
+    else { deltais=ideal(delt); eis=e; conj2=conj_factor; }
     if (defined(HNDebugOn)) {"roots of char. poly:";deltais;
                              "with multiplicities:",eis;}
     if (needext==1) {
- //--------------------- fuehre den Ringwechsel aus: --------------------------
+      //--------------------- fuehre den Ringwechsel aus: ---------------------
       ringischanged=1;
       if ((size(parstr(basering))>0) && string(minpoly)=="0") {
-        " ** We've had bad luck! The HNE cannot completely be calculated!";
-                                   // HNE in transzendenter Erw. fehlgeschlagen
+        " ** We've had bad luck! The HNE cannot be calculated completely!";
+        // HNE in transzendenter Erweiterung fehlgeschlagen
         kill zerlege;
         ringischanged=0; break;    // weiter mit gefundenen Faktoren
       }
       if (parstr(basering)=="") {
-        EXTHNEnumber++;
-        splitring(zerlege,"EXTHNEring("+string(EXTHNEnumber)+")");
+        EXTHNEnumber++; 
+        def EXTHNEring(EXTHNEnumber) = splitring(zerlege);
+        setring EXTHNEring(EXTHNEnumber);
+
         poly transf=0;
         poly transfproc=0;
+        ring_changed=1;
+        export transfproc; 
       }
       else {
-        if (defined(translist)) { kill translist; } // Vermeidung einer Warnung
         if (numberofRingchanges>1) {  // ein Ringwechsel hat nicht gereicht
-         list translist=splitring(zerlege,"",list(transf,transfproc,faktoren));
-         poly transf=translist[1];
-         poly transfproc=translist[2];
-         list faktoren=translist[3];
+         def helpring = splitring(zerlege,list(transf,transfproc,faktoren)); 
+         kill EXTHNEring(EXTHNEnumber);
+         def EXTHNEring(EXTHNEnumber)=helpring;
+         setring EXTHNEring(EXTHNEnumber);
+         kill helpring;
+
+         poly transf=erg[1];
+         poly transfproc=erg[2];
+         ring_changed=1;
+         list faktoren=erg[3];
+         export transfproc;
+         kill erg;
         }
         else {
-         if (defined(transfproc)) { // in dieser proc geschah schon Ringwechsel
+         if (ring_changed==1) { // in dieser proc geschah schon Ringwechsel
           EXTHNEnumber++;
-          list translist=splitring(zerlege,"EXTHNEring("
-               +string(EXTHNEnumber)+")",list(a,transfproc));
-          poly transf=translist[1];
-          poly transfproc=translist[2];
+          def EXTHNEring(EXTHNEnumber) = splitring(zerlege,list(a,transfproc));
+          setring EXTHNEring(EXTHNEnumber);
+          poly transf=erg[1];
+          poly transfproc=erg[2];
+          export transfproc;
+          kill erg;
          }
-         else {
+         else { // parameter war vorher da
           EXTHNEnumber++;
-          list translist=splitring(zerlege,"EXTHNEring("
-               +string(EXTHNEnumber)+")",a);
-          poly transf=translist[1];
+          def EXTHNEring(EXTHNEnumber) = splitring(zerlege,a);
+          setring EXTHNEring(EXTHNEnumber);
+          poly transf=erg[1];
           poly transfproc=transf;
+          ring_changed=1;
+          export transfproc;
+          kill erg;
         }}
       }
- //----------------------------------------------------------------------------
- // transf enthaelt jetzt den alten Parameter des Ringes, der aktiv war vor
- // Beginn der Schleife (evtl. also ueber mehrere Ringwechsel weitergereicht),
- // transfproc enthaelt den alten Parm. des R., der aktiv war zu Beginn der
- // Prozedur, und der an die aufrufende Prozedur zurueckgegeben werden muss
- // transf ist Null, falls der alte Ring keinen Parameter hatte,
- // das gleiche gilt fuer transfproc
- //----------------------------------------------------------------------------
-
- //------ Neudef. von Variablen, Uebertragung bisher errechneter Daten: -------
+      //-----------------------------------------------------------------------
+      // transf enthaelt jetzt den alten Parameter des Ringes, der aktiv war 
+      // vor Beginn der Schleife (evtl. also ueber mehrere Ringwechsel 
+      // weitergereicht), 
+      // transfproc enthaelt den alten Parameter des Ringes, der aktiv war zu 
+      // Beginn der Prozedur, und der an die aufrufende Prozedur zurueckgegeben
+      // werden muss 
+      // transf ist Null, falls der alte Ring keinen Parameter hatte,
+      // das gleiche gilt fuer transfproc
+      //-----------------------------------------------------------------------
+
+      //---- Neudef. von Variablen, Uebertragung bisher errechneter Daten: ----
       poly leitf,teiler,transformiert;
       list aneu=ideal(0);
@@ -3740,13 +3576,32 @@
       setring HNE_noparam;
       if (defined(letztring)) { kill letztring; }
-      if (lastRingnumber>0) { def letztring=EXTHNEring(lastRingnumber); }
-      else                  { def letztring=HNEring; }
+      if (EXTHNEnumber>1) { def letztring=EXTHNEring(EXTHNEnumber-1); }
+      else                { def letztring=HNEring; }
+      if (not defined(fneu)) {poly fneu;}
+      fneu=imap(letztring,fneu);
+      if (not defined(f)) {poly f;}
       f=imap(letztring,f);
+      if (not defined(hne)) {list hne;}
+      hne=imap(letztring,hne);
+
+      if (not defined(faktoren)) {list faktoren; }
       faktoren=imap(letztring,faktoren);
+        
+      if (not(defined(azeilen))){list azeilen,HNEs;}
+      azeilen=imap(letztring,azeilen);
+      HNEs=imap(letztring,HNEs);
+
       setring EXTHNEring(EXTHNEnumber);
-      map hole=HNE_noparam,transf,x,y;
-      poly f=hole(f);
-      if (not defined(faktoren)) {
-        list faktoren=hole(faktoren);
+      if (not(defined(hole))) { map hole; }
+      hole=HNE_noparam,transf,x,y;
+      poly fneu=hole(fneu);
+      if (not defined(faktoren)) {list faktoren;}
+      faktoren=hole(faktoren);
+
+      if (not(defined(f)))
+      {
+        poly f=hole(f);
+        list hne=hole(hne);
+        export f,hne;      
       }
     }
@@ -3755,10 +3610,12 @@
    if (eis==0) { i++; continue; }
    if (ringischanged==1) {
-    list erg,hilflist,HNEakut;            // dienen nur zum Sp. von Zwi.erg.
+    list erg,HNEakut;            // dienen nur zum Sp. von Zwi.erg.
+
     ideal hilfid;
-    erg=ideal(0); hilflist=erg; HNEakut=erg;
+    erg=ideal(0); HNEakut=erg;
 
     hole=HNE_noparam,transf,x,y;
     setring HNE_noparam;
+    if (not(defined(azeilen))){list azeilen,HNEs;}
     azeilen=imap(letztring,azeilen);
     HNEs=imap(letztring,HNEs);
@@ -3771,11 +3628,12 @@
    }
 
- //============ Schleife fuer jeden gefundenen Faktor der Leitform: ===========
+   //============ Schleife fuer jeden gefundenen Faktor der Leitform: =========
    for (j=1; j<=size(eis); j++) {
- //-- Mache Transf. T1 oder T2, trage Daten in HNEs ein, falls HNE abbricht: --
-
- //------------------------ Fall R==0: ----------------------------------------
+     //---- Mache Transformation T1 oder T2, trage Daten in HNEs ein, 
+     //     falls HNE abbricht: ----
+
+    //------------------------ Fall R==0: -------------------------------------
     if (R==0) {
-      transformiert = T1_Transform(f,number(deltais[j]),M/ e);
+      transformiert = T1_Transform(fneu,number(deltais[j]),M/ e);
       if (defined(HNDebugOn)) {
         "a("+string(zeile)+","+string(Q)+") =",deltais[j];
@@ -3785,5 +3643,5 @@
        dbprint(printlevel-voice+3,"finite HNE found");
        hnezaehler++;
- //------------ trage deltais[j],x ein in letzte Zeile, fertig: ---------------
+       //-------- trage deltais[j],x ein in letzte Zeile, fertig: -------------
        HNEakut=azeilen+list(poly(0));        // =HNEs[hnezaehler];
        hilfid=HNEakut[zeile+2]; hilfid[Q]=deltais[j]; hilfid[Q+1]=x;
@@ -3791,10 +3649,11 @@
        HNEakut[1][zeile+1]=Q;                // aktualisiere Vektor mit den hqs
        HNEs[hnezaehler]=HNEakut;
+       conj1[hneshift+hnezaehler]=conj2[j];
        if (eis[j]>1) {
         transformiert=transformiert/y;
-        if (subst(transformiert,y,0)==0) {
- "THE TEST FOR SQUAREFREENESS WAS BAD!! The polynomial was NOT squarefree!!!";}
+        if (subst(transformiert,y,0)==0){"THE TEST FOR SQUAREFREENESS WAS BAD!"
+                                  +"! The polynomial was NOT squarefree!!!";}
         else {
- //------ Spezialfall (###) eingetreten: Noch weitere Zweige vorhanden --------
+          //--- Spezialfall (###) eingetreten: Noch weitere Zweige vorhanden --
           eis[j]=eis[j]-1;
         }
@@ -3803,6 +3662,6 @@
     }
     else {
- //------------------------ Fall R <> 0: --------------------------------------
-      erg=T2_Transform(f,number(deltais[j]),M,N,referencepoly(Newton));
+      //------------------------ Fall R <> 0: ---------------------------------
+      erg=T2_Transform(fneu,number(deltais[j]),M,N,referencepoly(Newton));
       transformiert=erg[1];delt=erg[2];
       if (defined(HNDebugOn)) {"transformed polynomial: ",transformiert;}
@@ -3810,15 +3669,16 @@
        dbprint(printlevel-voice+3,"finite HNE found");
        hnezaehler++;
- //---------------- trage endliche HNE in HNEs ein: ---------------------------
+       //---------------- trage endliche HNE in HNEs ein: ---------------------
        HNEakut=azeilen;           // dupliziere den gemeins. Anfang der HNE's
        zl=2;                      // (kommt schliesslich nach HNEs[hnezaehler])
- //----------------------------------------------------------------------------
- // Werte von:  zeile: aktuelle Zeilennummer der HNE (gemeinsamer Teil)
- //             zl   : die HNE spaltet auf; zeile+zl ist der Index fuer die
- // Zeile des aktuellen Zweigs; (zeile+zl-2) ist die tatsaechl. Zeilennr.
- // (bei 0 angefangen) der HNE  ([1] <- intvec(hqs), [2] <- 0. Zeile usw.)
- //----------------------------------------------------------------------------
-
- //---------- vollziehe Euklid.Alg. nach, um die HN-Matrix zu berechnen: ------
+       //----------------------------------------------------------------------
+       // Werte von:  zeile: aktuelle Zeilennummer der HNE (gemeinsamer Teil)
+       //             zl : die HNE spaltet auf; zeile+zl ist der Index fuer die
+       //                  Zeile des aktuellen Zweigs; (zeile+zl-2) ist die 
+       //                  tatsaechl. Zeilennr. (bei 0 angefangen) der HNE  
+       //                  ([1] <- intvec(hqs), [2] <- 0. Zeile usw.)
+       //----------------------------------------------------------------------
+
+       //----- vollziehe Euklid.Alg. nach, um die HN-Matrix zu berechnen: -----
        M1=M;N1=N;R1=R;Q1=M1/ N1;
        while (R1!=0) {
@@ -3828,5 +3688,5 @@
                                   // markiere das Zeilenende der HNE
         zl=zl+1;
- //-------- Bereitstellung von Speicherplatz fuer eine neue Zeile: ------------
+        //----- Bereitstellung von Speicherplatz fuer eine neue Zeile: --------
         HNEakut[zeile+zl]=ideal(0);
 
